'use strict';
var child_process = require('child_process');
var path = require('path');
function main() {
    'use strict';
    var pathToScript = process.argv[1];
    var args = process.argv.slice(2);
    if (args.length < 1) {
        var usage = 'usage: ' + path.basename(pathToScript) + ' CMD [ARGS...]\n';
        process.stderr.write(usage, function (err) {
            process.exit(1);
        });
        return;
    }
    var opts = {
        stdio: [0, 1, 2],
    };
    var child = child_process.spawn(args[0], args.slice(1), opts);
    child.on('error', function (err) {
        process.stderr.write('error: ' + err, function () {
            process.exit(1);
        });
    });
    child.on('exit', function (code) {
        process.exit(code);
    });
}
main();
