'use strict';
var child_process = require('child_process');
var path = require('path');
function main() {
    'use strict';
    var pathToScript = process.argv[1];
    var args = process.argv.slice(2);
    if (!args.length) {
        var usage = 'usage: ' + path.basename(pathToScript) + ' CMD\n';
        process.stderr.write(usage, function (err) {
            process.exit(1);
        });
        return;
    }
    var opts = {
        stdio: [0, 1, 2],
    };
    var ordering = [];
    function finished(name) {
        ordering.push(name);
        if (ordering.length === 2) {
            var err_1 = ordering[0] === 'fast' ? 0 : 1;
            if (err_1) {
                process.stderr.write('fast finished last\n', function () {
                    process.exit(err_1);
                });
                return;
            }
            process.exit(err_1);
        }
    }
    var slowChild = child_process.spawn(args[0], ['20', '20000'], opts);
    slowChild.on('error', function (err) {
        process.stderr.write('error: ' + err, function () {
            finished('slow');
        });
    });
    slowChild.on('exit', function (code) {
        process.stderr.write('slow done\n', function () {
            finished('slow');
        });
    });
    var fastChild = child_process.spawn(args[0], ['0', '20000'], opts);
    fastChild.on('error', function (err) {
        process.stderr.write('error: ' + err, function () {
            finished('fast');
        });
    });
    fastChild.on('exit', function (code) {
        process.stderr.write('fast done\n', function () {
            finished('fast');
        });
    });
}
main();
