export declare class FSReqWrap {
    oncomplete: (err: any, ...rest: any[]) => void;
    context: any;
    constructor();
    complete(...args: any[]): void;
}
export declare class Stats {
    dev: number;
    mode: number;
    nlink: number;
    uid: number;
    gid: number;
    rdev: number;
    blksize: number;
    ino: number;
    size: number;
    blocks: number;
    atime: Date;
    mtime: Date;
    ctime: Date;
    birthtime: Date;
    constructor();
    _updateBirthtime(): void;
    _checkModeProperty(property: any): boolean;
    isDirectory(): boolean;
    isFile(): boolean;
    isBlockDevice(): boolean;
    isCharacterDevice(): boolean;
    isSymbolicLink(): boolean;
    isFIFO(): boolean;
    isSocket(): boolean;
}
export declare function FSInitialize(stats: any): void;
export declare function open(path: string, flags: string, mode: number, req: FSReqWrap): void;
export declare function unlink(path: string, req: FSReqWrap): void;
export declare function rmdir(path: string, req: FSReqWrap): void;
export declare function mkdir(path: string, mode: number, req: FSReqWrap): void;
export declare function utimes(path: string, atime: number, mtime: number, req: FSReqWrap): void;
export declare function futimes(fd: number, atime: number, mtime: number, req: FSReqWrap): void;
export declare function readdir(path: string, req: FSReqWrap): void;
export declare function fstat(fd: number, req: FSReqWrap): void;
export declare function lstat(path: string, req: FSReqWrap): void;
export declare function stat(path: string, req: FSReqWrap): void;
export declare function read(fd: number, buffer: any, offset: number, len: number, pos: number, req: FSReqWrap): void;
export declare function writeBuffer(fd: number, buffer: any, offset: number, len: number, pos: number, req: FSReqWrap): void;
export declare function writeBuffers(fd: number, chunks: any, pos: number, req: FSReqWrap): void;
export declare function close(fd: number, req: FSReqWrap): void;
