import { SyscallResponse } from '../syscall';
export interface Environment {
    [k: string]: string;
}
export interface File {
    type: string;
    fd: number;
    readable: boolean;
    writable: boolean;
}
export interface SpawnOptions {
    cwd: string;
    file: string;
    args: string[];
    envPairs: string[];
    stdio: File[];
    detached: boolean;
    uid: number;
    gid: number;
}
export declare class Process {
    onerror: Function;
    onexit: Function;
    pid: number;
    constructor();
    spawn(opts: SpawnOptions): any;
    close(): void;
    ref(): void;
    unref(): void;
    handleSigchild(data: SyscallResponse): void;
}
