import { StreamWrap, WriteWrap } from './stream_wrap';
export declare class Req {
    localAddress: string;
    localPort: number;
    address: string;
    port: number;
}
export declare class TCPConnectWrap {
    oncomplete: (status: number, handle: TCP, req: Req, readable: boolean, writable: boolean) => void;
    address: string;
    port: number;
    fd: number;
    constructor(fd?: number);
}
export declare class TCP extends StreamWrap {
    fd: number;
    owner: any;
    bound: boolean;
    listenPending: boolean;
    backlog: number;
    onconnection: Function;
    onread: Function;
    addr: string;
    port: number;
    constructor(fd?: number, bound?: boolean);
    getpeername(out: any): void;
    close(cb: () => void): void;
    connect(conn: TCPConnectWrap, addr: string, port: number): void;
    bind6(ipAddr: string, port: number): number;
    bind(ipAddr: string, port: number): number;
    listen(backlog: number): number;
    writeBinaryString(req: WriteWrap, data: string): void;
    writeUtf8String(req: WriteWrap, data: string): void;
    readStart(): void;
    private _read();
    private _listen();
    private _accept();
}
