/// <reference path="../../typings/index.d.ts" />
import { IKernel, IFile } from './types';
export declare function resolve(...args: string[]): string;
export declare class RegularFile implements IFile {
    kernel: IKernel;
    fd: number;
    pos: number;
    refCount: number;
    constructor(kernel: IKernel, fd: number);
    read(buf: Buffer, pos: number, cb: (err: any, len?: number) => void): void;
    write(buf: Buffer, pos: number, cb: (err: any, len?: number) => void): void;
    stat(cb: (err: any, stats: any) => void): void;
    readdir(cb: (err: any, files: string[]) => void): void;
    llseek(offhi: number, offlo: number, whence: number, cb: (err: number, off: number) => void): void;
    ref(): void;
    unref(): void;
}
export declare class DirFile implements IFile {
    kernel: IKernel;
    path: string;
    off: number;
    refCount: number;
    constructor(kernel: IKernel, path: string);
    read(buf: Buffer, pos: number, cb: (err: any, len?: number) => void): void;
    write(buf: Buffer, pos: number, cb: (err: any, len?: number) => void): void;
    stat(cb: (err: any, stats: any) => void): void;
    readdir(cb: (err: any, files: string[]) => void): void;
    llseek(offhi: number, offlo: number, whence: number, cb: (err: number, off: number) => void): void;
    getdents(buf: Uint8Array, cb: (err: number) => void): void;
    ref(): void;
    unref(): void;
}
export declare class NullFile implements IFile {
    fd: number;
    pos: number;
    refCount: number;
    constructor();
    read(buf: Buffer, pos: number, cb: (err: any, len?: number) => void): void;
    write(buf: Buffer, pos: number, cb: (err: any, len?: number) => void): void;
    stat(cb: (err: any, stats: any) => void): void;
    readdir(cb: (err: any, files: string[]) => void): void;
    llseek(offhi: number, offlo: number, whence: number, cb: (err: number, off: number) => void): void;
    ref(): void;
    unref(): void;
}
