/// <reference path="../../typings/index.d.ts" />
import { IFile, OutputCallback, RWCallback } from './types';
export declare class Pipe {
    buf: Buffer;
    refcount: number;
    readWaiter: Function;
    writeWaiter: Function;
    closed: boolean;
    write(s: string): void;
    writeBuffer(b: Buffer, cb: RWCallback): void;
    read(buf: Buffer, off: number, len: number, pos: number, cb: RWCallback): void;
    readSync(): Buffer;
    ref(): void;
    unref(): void;
}
export declare function isPipe(f: IFile): f is PipeFile;
export declare class PipeFile implements IFile {
    pipe: Pipe;
    writeListener: OutputCallback;
    constructor(pipe?: Pipe);
    addEventListener(evName: string, cb: OutputCallback): void;
    read(buf: Buffer, pos: number, cb: RWCallback): void;
    write(buf: Buffer, pos: number, cb: RWCallback): void;
    stat(cb: (err: any, stats: any) => void): void;
    llseek(offhi: number, offlo: number, whence: number, cb: (err: number, off: number) => void): void;
    readdir(cb: (err: any, files: string[]) => void): void;
    readSync(): Buffer;
    ref(): void;
    unref(): void;
}
