/// <reference path="../../typings/index.d.ts" />
import { ConnectCallback, RWCallback, IFile, ITask } from './types';
import { Pipe } from './pipe';
export interface AcceptCallback {
    (err: number, s?: SocketFile, remoteAddr?: string, remotePort?: number): void;
}
export declare function isSocket(f: IFile): f is SocketFile;
export interface Incoming {
    s: SocketFile;
    addr: string;
    port: number;
    cb: ConnectCallback;
}
export declare class SocketFile implements IFile {
    task: ITask;
    isListening: boolean;
    parent: SocketFile;
    refCount: number;
    port: number;
    addr: string;
    peer: SocketFile;
    outgoing: Pipe;
    incoming: Pipe;
    incomingQueue: Incoming[];
    acceptQueue: AcceptCallback[];
    constructor(task: ITask);
    stat(cb: (err: any, stats: any) => void): void;
    readdir(cb: (err: any, files: string[]) => void): void;
    listen(cb: (err: number) => void): void;
    accept(cb: AcceptCallback): void;
    doAccept(remote: SocketFile, remoteAddr: string, remotePort: number, cb: ConnectCallback): void;
    connect(addr: string, port: number, cb: ConnectCallback): void;
    read(buf: Buffer, pos: number, cb: RWCallback): void;
    write(buf: Buffer, pos: number, cb: RWCallback): void;
    readSync(): Buffer;
    llseek(offhi: number, offlo: number, whence: number, cb: (err: number, off: number) => void): void;
    ref(): void;
    unref(): void;
}
