'use strict';
var SyscallContext = (function () {
    function SyscallContext(task, id) {
        this.task = task;
        this.id = id;
    }
    SyscallContext.prototype.complete = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i - 0] = arguments[_i];
        }
        this.task.schedule({
            id: this.id,
            name: undefined,
            args: args,
        });
    };
    return SyscallContext;
}());
exports.SyscallContext = SyscallContext;
var Syscall = (function () {
    function Syscall(ctx, name, args) {
        this.ctx = ctx;
        this.name = name;
        this.args = args;
    }
    Syscall.From = function (task, ev) {
        if (!ev.data)
            return;
        for (var i = 0; i < Syscall.requiredOnData.length; i++) {
            if (!ev.data.hasOwnProperty(Syscall.requiredOnData[i]))
                return;
        }
        var ctx = new SyscallContext(task, ev.data.id);
        return new Syscall(ctx, ev.data.name, ev.data.args);
    };
    Syscall.prototype.callArgs = function () {
        return [this.ctx].concat(this.args);
    };
    Syscall.requiredOnData = ['id', 'name', 'args'];
    return Syscall;
}());
exports.Syscall = Syscall;
