'use strict';
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var syscall_1 = require('../browser-node/syscall');
var table_1 = require('./table');
function Syscall(cb, trap) {
    table_1.syscallTbl[trap].apply(this, arguments);
}
exports.Syscall = Syscall;
;
exports.Syscall6 = Syscall;
exports.internal = syscall_1.syscall;
var OnceEmitter = (function () {
    function OnceEmitter() {
        this.listeners = {};
    }
    OnceEmitter.prototype.once = function (event, cb) {
        var cbs = this.listeners[event];
        if (!cbs)
            cbs = [cb];
        else
            cbs.push(cb);
        this.listeners[event] = cbs;
    };
    OnceEmitter.prototype.emit = function (event) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        var cbs = this.listeners[event];
        this.listeners[event] = [];
        if (!cbs)
            return;
        for (var i = 0; i < cbs.length; i++) {
            cbs[i].apply(null, args);
        }
    };
    return OnceEmitter;
}());
var Process = (function (_super) {
    __extends(Process, _super);
    function Process(argv, environ) {
        _super.call(this);
        this.argv = argv;
        this.env = environ;
    }
    Process.prototype.exit = function (code) {
        if (code === void 0) { code = 0; }
        syscall_1.syscall.exit(code);
    };
    return Process;
}(OnceEmitter));
var process = new Process(null, null);
syscall_1.syscall.addEventListener('init', init.bind(this));
function init(data) {
    'use strict';
    var args = data.args[0];
    var environ = data.args[1];
    args = [args[0]].concat(args);
    process.argv = args;
    process.env = environ;
    setTimeout(function () { process.emit('ready'); }, 0);
}
if (typeof window !== "undefined") {
    window.$syscall = exports;
    window.process = process;
}
else if (typeof self !== "undefined") {
    self.$syscall = exports;
    self.process = process;
}
else if (typeof global !== "undefined") {
    global.$syscall = exports;
}
else {
    this.$syscall = exports;
    this.process = process;
}
